unit Unit1;

//programme par Yoann
//http://delphipage.free.fr/

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, IniFiles;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Quitter1: TMenuItem;
    N1: TMenuItem;
    Ouvrir1: TMenuItem;
    favbarre: TMenuItem;
    fav1: TMenuItem;
    fav2: TMenuItem;
    fav3: TMenuItem;
    fav4: TMenuItem;
    OpenDialog1: TOpenDialog;
    Image1: TImage;
    procedure Ouvrir1Click(Sender: TObject);
    procedure fav1Click(Sender: TObject);
    procedure fav2Click(Sender: TObject);
    procedure fav3Click(Sender: TObject);
    procedure fav4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
  private
    { Dclarations prives }
    FavList: TStringList;
    Favchange: Boolean;
    procedure Ouvrirfav;
    procedure Organiserfav;
    procedure Adaptefav(const Filename: String);
    procedure Ecrirefav;
    procedure Ouvrir(const Filename: String);
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  const Maxfav=4; //Nombre de favoris maximum dans le menu (vous pouvez modifier se nombre)

implementation

{$R *.DFM}

procedure TForm1.Ouvrirfav; //Rcupre les diffrents chemins de fichiers dans le stringlist
Var FichierIni: TIniFile;
i: Integer;
St: String;
begin
FavList:=TStringList.Create; //Cre un stringlist
FichierIni:=TIniFile.Create('Monfichier.ini'); //Cre le fichier ini si il n'existe pas
for i:=1 to Maxfav do //Pour chaque favoris ...
begin
St:=FichierIni.ReadString('Favoris',Concat('fav',IntToStr(i)),''); //Lit les diffrents chemin de fichier
FavList.Add(St); //On ajoute les diffrentes chemin de fichier stringlist
end;
while FavList.IndexOf('') <> -1 do //Si il y a des blancs, on les supprime dans le stringlist
Favlist.Delete(FavList.IndexOf(''));
end;

procedure TForm1.Organiserfav; //Affiche le texte des chemins de fichiers dans le menu
Var MenuItem: TMenuItem;
i: Integer;
begin
i:=0; //Initialise la variable "i"  0
while (i < (Favlist.Count)) and (i < Maxfav) do //Pour chaque item "fav" du menu...
begin
MenuItem:=TMenuItem(FindComponent(concat('fav',IntToStr(i+1)))); //Recherche dans les diffrents item du menu portant le nom de fav(fav1,fav2,...)
MenuItem.Visible:=True; //Affiche l'item du menu
MenuItem.Caption:=FavList.Strings[i]; //Enregistre le texte de l'item dans le stringlist
Inc(i); //Incrmente la variable i
end;
favbarre.Visible:=fav1.Visible; //Si il y a alors on affiche une barre dans le menu
end;

procedure TForm1.Adaptefav(const Filename: String); //Ajoute le nouveau chemin de fichier et supprime le dernier ou change la position du chemin de fichier
begin
FavChange:=True; //Indique qu'il y a eu un changement dans le menu
if FavList.IndexOf(Filename)=-1 then //Si le nouveau chemin de fichier n'a pas t trouv alors...
begin
FavList.Insert(0,Filename); //On insre le nouveau chemin de fichier  la premire place
if FavList.Count > MAXfav then //Si le nombre de string est suprieur au nombre de favoris maximum dans le menu
FavList.Delete(MAXfav); //Supprime le dernier chemin de fichier
end
else //Sinon...
FavList.Move(FavList.IndexOf(Filename),0); //Change la position d'un chemin de fichier dj existant dans le stringlist en la mettant en premier
Organiserfav; //Appel la procedure "Organiserfav"
end;

procedure TForm1.Ecrirefav; //Enregistre les items "fav" du menu
Var FichierIni: TIniFile;
i: Integer;
begin
if FavChange then  //Si il y a eu un changement dans le menu alors...
begin
FichierIni:=TIniFile.Create('Monfichier.ini'); //Cre le fichier ini si il n'existe pas
i:=0; //Initialise la variable "i"  0
while (i < (Favlist.Count)) and (i < Maxfav) do //Pour chaque item "fav" du menu...
begin
FichierIni.WriteString('Favoris',concat('fav',IntToStr(i+1)),Favlist.Strings[i]); //Enregistre les chemin des fichiers des items du menu
Inc(i); //Incrmente la variable i
end;
end;
end;

procedure TForm1.Ouvrir(const Filename: String);
begin
Image1.Picture.LoadFromFile(FileName); //Ouvre le fichier dans le composant TImage
Adaptefav(FileName); //Appel la procedure "Adaptefav" avec comme paramtre "OpenDialog1.FileName"
end;

procedure TForm1.Ouvrir1Click(Sender: TObject);
begin
if OpenDialog1.Execute then //Lance la fentre d'ouverture de fichier et si l'utilisateur clique sur le bouton "Ouvrir"
Ouvrir(OpenDialog1.FileName); //Appel la procedure "Ouvrir" avec comme paramtre "OpenDialog1.FileName"
end;

procedure TForm1.fav1Click(Sender: TObject);
begin
Ouvrir(fav1.Caption); //Appel la procedure "Ouvrir" avec le paramtre "fav1.Caption"
//"fav1.Caption" correspond au chemin du fichier
end;

procedure TForm1.fav2Click(Sender: TObject);
begin
Ouvrir(fav2.Caption);
end;

procedure TForm1.fav3Click(Sender: TObject);
begin
Ouvrir(fav3.Caption);
end;

procedure TForm1.fav4Click(Sender: TObject);
begin
Ouvrir(fav4.Caption);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Ouvrirfav; //Appel la procedure "Ouvrirfav"
Organiserfav; //Appel la procedure "Organiserfav"
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
Ecrirefav; //Appel la procedure "Ecrirefav"
Favlist.Free; //Dtruit l'objet
end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
Close; //Quitte l'application
end;

end.
